#include <fstream>
#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <cmath>

using namespace std;

int n, m;
double k;

int main(int argc, char* argv[])
{
	istringstream ss_randseed(argv[1]);
	istringstream ss_n(argv[2]);
	istringstream ss_m(argv[3]);
	istringstream ss_k(argv[4]);

	int randseed;
	ss_randseed >> randseed;
	srand(randseed);

	ss_n >> n;
	ss_m >> m;
	ss_k >> k;

	cout << n << " " << m << endl;
	for (int i = 0; i < n; i++) {
		cout << rand() % 1001 << " " << rand() % 1001 << endl;
	}
	for (int i = 0; i < m; i++) {
		int x1 = rand() % 1001;
		int y1 = rand() % 1001;
		int x2 = rand() % 1001;
		int y2 = rand() % 1001;
		int sqd = (x2-x1)*(x2-x1) + (y2-y1)*(y2-y1);
		int d = k * sqrt(sqd+0.0);
		while (d*d < sqd) d++;
		if (d > 10000) d = 10000;
		cout << x1 << " " << y1 << " " << x2 << " " << y2 << " " << d << endl;
	}
        
	return 0;
}
